SystemOrganization addCategory: #PaulLePoulpe!
SystemOrganization addCategory: #'PaulLePoulpe-Configuration'!
SystemOrganization addCategory: #'PaulLePoulpe-Examples'!
SystemOrganization addCategory: #'PaulLePoulpe-Filter'!
SystemOrganization addCategory: #'PaulLePoulpe-Formatter'!
SystemOrganization addCategory: #'PaulLePoulpe-Holder'!
SystemOrganization addCategory: #'PaulLePoulpe-Test'!
SystemOrganization addCategory: #'PaulLePoulpe-Writer'!

Trait named: #TLogger
	uses: {}
	category: 'PaulLePoulpe'!

!TLogger commentStamp: '<historical>' prior: 0!
Just add this trait to your object and you'll be able to log as configuration say :)

For configuration you must go to LogConfiguration at configuration class method, that initialize the configuration on LogConfigurationHolder (a singleton with all configurations).

To reset configuration just execute LogConfigurationHolder reset

!

!TLogger classSide methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 22:57'!
configurationOfLog
	<logConfigurationAs: #default>! !

!TLogger classSide methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 23:05'!
resetConfiguration
	LogConfigurationHolder reset.! !

!TLogger methodsFor: 'logging' stamp: 'SantiagoBragagnolo 5/31/2012 03:34'!
debug: aLog
	self processor process: (LogEntity for:aLog in: thisContext sender with:#debug).! !

!TLogger methodsFor: 'logging' stamp: 'SantiagoBragagnolo 5/31/2012 03:33'!
info: aLog
	self processor process: (LogEntity for:aLog in: thisContext sender with:#info).! !

!TLogger methodsFor: 'logging' stamp: 'SantiagoBragagnolo 6/2/2012 00:28'!
logError: aLog
	self processor process: (LogEntity for:aLog in: thisContext sender with:#error).! !

!TLogger methodsFor: 'logging-processor' stamp: 'SantiagoBragagnolo 5/31/2012 23:49'!
processor
	^LogConfigurationHolder instance forClass: self class.! !

!TLogger methodsFor: 'logging' stamp: 'SantiagoBragagnolo 5/31/2012 03:34'!
transaction: aLog
	self processor process: (LogEntity for:aLog in: thisContext sender with:#transaction).! !

!TLogger methodsFor: 'logging' stamp: 'SantiagoBragagnolo 5/31/2012 03:34'!
warn: aLog
	self processor process: (LogEntity for:aLog in: thisContext sender with:#warn).! !

TestCase subclass: #LogConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

!LogConfigurationTest methodsFor: 'test - configuration' stamp: 'SantiagoBragagnolo 6/2/2012 00:04'!
testConfigurationCategorySimpleFormatterStdoutwriterHold
	| processor | 
	processor := LogConfiguration forKey: #key useCategory: #transaction showingLogAs: #simple into: #stdout holdLogInstances: true.
	
	self assert: (processor filter isKindOf: CategoryLogFilter ) description:'Spected filter type CategoryLogFilter'.
	self assert: (processor filter category =#transaction ) description:'Spected category: #transaction '.
	self assert: (processor writer isKindOf: LogStdoutWriter  ) description:'Spected writer type LogStdoutWriter '.
	self assert: (processor formatter isKindOf: SimpleLogFormatter ) description:'Spected formatter type SimpleLogFormatter '.
	self assert: processor hold description: ' Hold must be setted as true '.
	! !

!LogConfigurationTest methodsFor: 'test - configuration' stamp: 'SantiagoBragagnolo 6/2/2012 00:12'!
testConfigurationLevelPatternFormatterFileWriterHoldFalse
	| processor | 
	processor := LogConfiguration forKey: #key useLevel: #transaction showingLogAs:( '%class' asPatternFormatter) into:( 'bla.txt' asLogWriter )holdLogInstances: false.
	
	self assert: (processor filter isKindOf: LevelLogFilter ) description:'Spected filter type CategoryLogFilter'.
	self assert: (processor filter category =#transaction ) description:'Spected level: #transaction '.
	self assert: (processor writer isKindOf: LogFileWriter  ) description:'Spected writer type LogFileWriter '.
	self assert: (processor formatter isKindOf: PatternLogFormatter ) description:'Spected formatter type PatternLogFormatter'.
	self assert: (processor hold not )description: ' Hold must be setted as false '.
	processor writer close.! !

TestCase subclass: #LogEntityBasedTest
	instanceVariableNames: 'info debug error warn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

!LogEntityBasedTest methodsFor: 'set up' stamp: 'SantiagoBragagnolo 6/1/2012 23:24'!
setUp
	info := LogEntity for:['something'] in: thisContext sender with:#info.
	debug := LogEntity for:['something'] in: thisContext sender with:#debug.
	error := LogEntity for:['something'] in: thisContext sender with:#error.
	warn := LogEntity for:['something'] in: thisContext sender with:#warn.! !

LogEntityBasedTest subclass: #LogFilterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

!LogFilterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:15'!
testInfoCategoryFilterAccepted
	| categoryFilter value |
	categoryFilter := CategoryLogFilter for:#info.
	
	value := false.
	categoryFilter ifAccept: info do: [ value := true. ].
	
	self assert:[  value ] description:'CategoryFilter for #info must accept #info logEntity'.

	! !

!LogFilterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:19'!
testInfoCategoryFilterNotAccepted
	| categoryFilter value |
	categoryFilter := CategoryLogFilter for:#info.
	
	value := false.
	categoryFilter ifAccept: error do: [ value := true ].
	
	self assert:[  value = false ] description:'CategoryFilter for #info must NOT accept #error logEntity'.

	value := false.
	categoryFilter ifAccept: debug do: [ value := true ].
	
	self assert:[  value = false ] description:'CategoryFilter for #info must NOT accept #debug logEntity'.
	! !

!LogFilterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:21'!
testInfoHigherLevelFilterNotAccepted
	| levelFilter value |
	levelFilter := LevelLogFilter for:#warn.
	
	value := false.
	levelFilter ifAccept: info do: [ value := true. ].
	
	self assert:[  value = false ] description:'LevelLogFilter for #warn must NOT accept #error logEntity'.

	value := false.
	levelFilter ifAccept: debug do: [ value := true. ].
	
	self assert:[  value = false ] description:'LevelLogFilter for #warn must NOT accept #warn logEntity'.	! !

!LogFilterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:19'!
testInfoLowerLevelFilterAccepted
	| levelFilter value |
	levelFilter := LevelLogFilter for:#info.
	
	value := false.
	levelFilter ifAccept: error do: [ value := true. ].
	
	self assert:[  value ] description:'LevelLogFilter for #info must accept #error logEntity'.

	value := false.
	levelFilter ifAccept: warn do: [ value := true. ].
	
	self assert:[  value ] description:'LevelLogFilter for #info must accept #warn logEntity'.	! !

!LogFilterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:16'!
testInfoSameLevelFilterAccepted
	| levelFilter value |
	levelFilter := LevelLogFilter for:#info.
	
	value := false.
	levelFilter ifAccept: info do: [ value := true. ].
	
	self assert:[  value ] description:'LevelLogFilter for #info must accept #info logEntity'.

	! !

LogEntityBasedTest subclass: #LogFormatterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:32'!
testCustomFormatter
	| formatter givenLog result | 
	
	result := [ :log | givenLog := log ] asCustomLogFormatter format: info.

	self assert: givenLog = info description:'CustomLogFormatter must receive info logEntity as parameter!! ' .
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:49'!
testPatternFormatterClassSelector
	| result | 
	
	result := ' %class %selector ' asPatternFormatter format:debug.
	
	self assert: result = ' LogFormatterTest runCase ' description:' Spected result: LogFormatterTest runCase  '.
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:40'!
testPatternFormatterClassSymbol
	| result | 
	
	result := PatternLogFormatter classSymbol asPatternFormatter format:info.
	
	self assert: result = 'LogFormatterTest' description:'class spected: LogFormatterTest'.	
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:39'!
testPatternFormatterEmptyArgument
	| result | 
	
	result := PatternLogFormatter argument asPatternFormatter format:info.
	
	self assert: result = '' description:'argument pattern spected: <empty string>'.	
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:42'!
testPatternFormatterSelector
	| result | 
	
	result := PatternLogFormatter selector asPatternFormatter format:info.
	
	self assert: result = 'runCase' description:'selector spected: runCase'.	" SUnit implementation is weird. "
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:46'!
testPatternFormatterTag
	| result | 
	
	result := PatternLogFormatter tag asPatternFormatter format:debug.
	
	self assert: result = 'debug' description:' Tag Spected: debug'.
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:46'!
testPatternFormatterTimeStamp
	| result | 
	
	result := PatternLogFormatter timestamp asPatternFormatter format:debug.
	
	self assert: result = debug timestamp asString description:' Spected timestamp: ', debug timestamp asString.
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	
	! !

!LogFormatterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:35'!
testSimpleFormatter
	| result | 
	
	result := SimpleLogFormatter new format: error.
	
	self assert: result = error asString description:'SimpleLogFormatter asString return spected!! ' .
	self assert: (result isKindOf: String  )description: 'A formatter MUST return a string value!!'.
	! !

TestCase subclass: #LogTestObject
	uses: TLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

LogTestObject class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!LogTestObject class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/2/2012 00:18'!
configurationOfLog
	<logConfiguration>
	^ [
	     :builder |
	     builder forClass:LogTestObject 
			     useLevel:#info 
			     showingLogAs: ('%pih | %tstmp | %tag #%class >> %selector [%log]' asPatternFormatter) 
			     into: #mem
			     holdLogInstances:true.
	].

! !

!LogTestObject methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/2/2012 00:18'!
setUp
	LogTestObject resetConfiguration.! !

!LogTestObject methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/2/2012 00:42'!
testHoldedLog
| conf logCol  holder |

	LogHolder reset.
	
	self info: 'an info log'.
	self debug: 'an debug log'.
	self logError: 'an error log'.
	
	conf := LogConfigurationHolder instance at:self class ifNotConfigured: [ 
		self assert: false description: 'Log configuration has not been loaded'	.
	]  .
	logCol := conf writer logs.

	self assert: logCol size = 2 description: ' sected elements: 2 '.
	self assert: (logCol contains: [ :str | str includesSubString:  'an info log' ]).
	self assert: (logCol contains: [ :str | str includesSubString:  'an error log' ]).
	holder := LogHolder instance collect: #yourself.
	self assert: holder size = 2 description: '2 Logs required in the holder!!'.! !

TestCase subclass: #LogWriterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Test'!

!LogWriterTest methodsFor: 'tests' stamp: 'SantiagoBragagnolo 6/1/2012 23:52'!
testMemoryWriterCollection
	| mem |
	mem := MemoryLogWritter new.
	mem write: 'something'.
	self assert: (mem logs first = 'something') description: 'something has not been writen at memoryWriter'! !

!BlockClosure methodsFor: '*PaulLePoulpe' stamp: 'SantiagoBragagnolo 5/31/2012 02:43'!
asCustomLogFormatter
	^CustomLogFormatter with:self.! !

!Array methodsFor: '*PaulLePoulpe' stamp: 'SantiagoBragagnolo 5/31/2012 22:51'!
asLogWriter
	^ LogCompositeWritter new:self.! !

!ByteString methodsFor: '*PaulLePoulpe' stamp: 'SantiagoBragagnolo 5/31/2012 23:38'!
asLogWriter
	^LogFileWriter for:self.! !

!ByteString methodsFor: '*PaulLePoulpe' stamp: 'SantiagoBragagnolo 5/31/2012 02:41'!
asPatternFormatter
	^PatternLogFormatter with:self.! !

Object subclass: #CustomLogFormatter
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Formatter'!

!CustomLogFormatter class methodsFor: 'constructors' stamp: 'SantiagoBragagnolo 5/31/2012 01:10'!
new 
	self error: 'CustomLogFormatter must be instanciated with with:aBlock class message'! !

!CustomLogFormatter class methodsFor: 'constructors' stamp: 'SantiagoBragagnolo 5/31/2012 03:48'!
with:aBlock 
	| i |
	i := self basicNew.
	^i block:aBlock; yourself .! !

!CustomLogFormatter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:11'!
block: aBlock
	block := aBlock.! !

!CustomLogFormatter methodsFor: 'format' stamp: 'SantiagoBragagnolo 6/1/2012 23:31'!
format: aLogEntity
	^(block value:aLogEntity) asString.! !

Object subclass: #LogCompositeWritter
	instanceVariableNames: 'writers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Writer'!

!LogCompositeWritter class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 5/31/2012 22:47'!
new:writtersArray
 |i | 
 i := self new.

	writtersArray do: [ :writter | 
		i addWriter: writter.
	].
^i.


! !

!LogCompositeWritter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 22:53'!
addWriter: aWriter
	writers add: aWriter.! !

!LogCompositeWritter methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 5/31/2012 22:40'!
initialize 
	writers := Set new.! !

!LogCompositeWritter methodsFor: 'write' stamp: 'SantiagoBragagnolo 5/31/2012 22:39'!
write: aString
	writers do:[ :writer | writer write: aString ].! !

Object subclass: #LogConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Configuration'!

!LogConfiguration class methodsFor: 'build' stamp: 'SantiagoBragagnolo 6/2/2012 00:56'!
configuration
	self for:[ :builder | 
		builder forKey:#default useLevel:#warn into: Transcript asLogWriter .
	] ! !

!LogConfiguration class methodsFor: 'build' stamp: 'SantiagoBragagnolo 5/31/2012 23:30'!
for: aBlock
| val |
	val := aBlock value: self.
	^val.! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:06'!
forClass: aClass useCategory: aCategory 
	^self forKey: aClass useCategory: aCategory.! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:07'!
forClass: aKey useCategory: aCategory into:aWriter 
	^self forKey: aKey useCategory: aCategory into:aWriter ! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 23:07'!
forClass: aKey useCategory: aCategory into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useCategory: aCategory into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:09'!
forClass: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter 
	^self forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter ! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 23:07'!
forClass: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:12'!
forClass: aKey useLevel: aLevel  
	^self forKey: aKey useLevel: aLevel  ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:12'!
forClass: aKey useLevel: aLevel  into:aWriter 
	^self forKey: aKey useLevel: aLevel  into:aWriter ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 23:08'!
forClass: aKey useLevel: aLevel  into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useLevel: aLevel  into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:15'!
forClass: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter 
	^self forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 23:08'!
forClass: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:06'!
forKey: aKey useCategory: aCategory 
	^LogConfigurationHolder instance at:aKey put: (self new useCategory: aCategory)! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:07'!
forKey: aKey useCategory: aCategory into:aWriter 
	^LogConfigurationHolder instance at:aKey put: (self new useCategory: aCategory into:aWriter)! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 23:06'!
forKey: aKey useCategory: aCategory into:aWriter holdLogInstances:aBoolean
	^LogConfigurationHolder instance at:aKey put: (self new useCategory: aCategory into:aWriter retain:aBoolean)! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:09'!
forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter 
	^LogConfigurationHolder instance at:aKey put: (self new useCategory: aCategory  showingLogAs: aFormatter into:aWriter )! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 23:07'!
forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^LogConfigurationHolder instance at:aKey put: (self new useCategory: aCategory  showingLogAs: aFormatter into:aWriter retain:aBoolean)! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:11'!
forKey: aKey useLevel: aLevel  
	^LogConfigurationHolder instance at:aKey put: (self new useLevel: aLevel  )! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:12'!
forKey: aKey useLevel: aLevel  into:aWriter 
	^LogConfigurationHolder instance at:aKey put: (self new useLevel: aLevel  into:aWriter  )! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 23:08'!
forKey: aKey useLevel: aLevel  into:aWriter holdLogInstances:aBoolean
	^LogConfigurationHolder instance at:aKey put: (self new useLevel: aLevel  into:aWriter retain:aBoolean )! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 03:14'!
forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter 
	^LogConfigurationHolder instance at:aKey put: (self new useLevel: aLevel showingLogAs: aFormatter into:aWriter )! !

!LogConfiguration class methodsFor: 'key' stamp: 'SantiagoBragagnolo 5/31/2012 23:07'!
forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^LogConfigurationHolder instance at:aKey put: (self new useLevel: aLevel showingLogAs: aFormatter into:aWriter retain:aBoolean)! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:07'!
forPackage: aPackage useCategory: aCategory 
	^self forKey: aPackage useCategory: aCategory.! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:07'!
forPackage: aKey useCategory: aCategory into:aWriter 
	^self forKey: aKey useCategory: aCategory into:aWriter ! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 23:07'!
forPackage: aKey useCategory: aCategory into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useCategory: aCategory into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 03:09'!
forPackage: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter 
	^self forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter ! !

!LogConfiguration class methodsFor: 'category' stamp: 'SantiagoBragagnolo 5/31/2012 23:08'!
forPackage: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useCategory: aCategory  showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:12'!
forPackage: aKey useLevel: aLevel  
	^self forKey: aKey useLevel: aLevel  ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:12'!
forPackage: aKey useLevel: aLevel  into:aWriter 
	^self forKey: aKey useLevel: aLevel  into:aWriter ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 23:08'!
forPackage: aKey useLevel: aLevel  into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useLevel: aLevel  into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 03:15'!
forPackage: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter 
	^self forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter ! !

!LogConfiguration class methodsFor: 'level' stamp: 'SantiagoBragagnolo 5/31/2012 23:09'!
forPackage: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean
	^self forKey: aKey useLevel: aLevel showingLogAs: aFormatter into:aWriter holdLogInstances:aBoolean! !

!LogConfiguration methodsFor: 'base' stamp: 'SantiagoBragagnolo 6/2/2012 00:46'!
filter: aFilter showingLogAs: aFormatter into:aWriter retain:aBoolean
| formatter writer | 
	formatter := aFormatter = #simple ifTrue: [ SimpleLogFormatter new]  ifFalse: [ aFormatter ].
	writer := aWriter  = #stdout ifTrue: [ LogStdoutWriter new]  ifFalse: [ aWriter ].
	writer := aWriter  = #mem ifTrue: [ MemoryLogWritter new]  ifFalse: [ writer ].
	
	^LogProcessor new 
				filter: aFilter;
				formatter: formatter; 
				writer: writer;
				hold:aBoolean;
				yourself.
				
			! !

!LogConfiguration methodsFor: 'use category' stamp: 'SantiagoBragagnolo 5/31/2012 02:57'!
useCategory: aCategory 
	^self filter: (CategoryLogFilter for: aCategory ) showingLogAs: #simple into: (Transcript asLogWriter) retain:false.
			! !

!LogConfiguration methodsFor: 'use category' stamp: 'SantiagoBragagnolo 5/31/2012 02:56'!
useCategory: aCategory into:aWriter 
	^self filter: (CategoryLogFilter for: aCategory ) showingLogAs: #simple into:aWriter retain:false.
			! !

!LogConfiguration methodsFor: 'use category' stamp: 'SantiagoBragagnolo 5/31/2012 02:56'!
useCategory: aCategory into:aWriter retain:aBoolean
	^self filter: (CategoryLogFilter for: aCategory ) showingLogAs: #simple into:aWriter retain:aBoolean
			! !

!LogConfiguration methodsFor: 'use category' stamp: 'SantiagoBragagnolo 5/31/2012 02:54'!
useCategory: aCategory  showingLogAs: aFormatter into:aWriter 
	^self useCategory: aCategory  showingLogAs: aFormatter into:aWriter retain:false
			! !

!LogConfiguration methodsFor: 'use category' stamp: 'SantiagoBragagnolo 5/31/2012 02:52'!
useCategory: aCategory  showingLogAs: aFormatter into:aWriter retain:aBoolean
	^self filter: (CategoryLogFilter for: aCategory ) showingLogAs: aFormatter into:aWriter retain:aBoolean
			! !

!LogConfiguration methodsFor: 'use level' stamp: 'SantiagoBragagnolo 5/31/2012 03:01'!
useLevel: aLevel  
	^self filter: (LevelLogFilter for:aLevel) showingLogAs: #simple into: (Transcript asLogWriter) retain:false.
			! !

!LogConfiguration methodsFor: 'use level' stamp: 'SantiagoBragagnolo 5/31/2012 03:00'!
useLevel: aLevel  into:aWriter 
	^self filter: (LevelLogFilter for:aLevel) showingLogAs: #simple into:aWriter retain:false.
			! !

!LogConfiguration methodsFor: 'use level' stamp: 'SantiagoBragagnolo 5/31/2012 03:00'!
useLevel: aLevel  into:aWriter retain:aBoolean
	^self filter: (LevelLogFilter for:aLevel) showingLogAs: #simple into:aWriter retain:aBoolean
			! !

!LogConfiguration methodsFor: 'use level' stamp: 'SantiagoBragagnolo 5/31/2012 02:55'!
useLevel: aLevel showingLogAs: aFormatter into:aWriter 
	^self useLevel: aLevel showingLogAs: aFormatter into:aWriter retain:false.
			! !

!LogConfiguration methodsFor: 'use level' stamp: 'SantiagoBragagnolo 5/31/2012 02:51'!
useLevel: aLevel showingLogAs: aFormatter into:aWriter retain:aBoolean
	^self filter: (LevelLogFilter for:aLevel) showingLogAs: aFormatter into:aWriter retain:aBoolean
			! !

Object subclass: #LogConfigurationHolder
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Configuration'!

LogConfigurationHolder class
	instanceVariableNames: 'instance'!

LogConfigurationHolder class
	instanceVariableNames: 'instance'!

!LogConfigurationHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:39'!
instance
	instance ifNil:[
		instance := self basicNew.
		instance initialize.
	].
	^instance.! !

!LogConfigurationHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:32'!
new 
	self error: 'LogConfigurationHolder is a singleton!!'! !

!LogConfigurationHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:41'!
reset
	instance := nil.! !

!LogConfigurationHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 22:16'!
at:aConfigurationKey ifNotConfigured:aBlock
	^dict at:aConfigurationKey ifAbsent:aBlock.
	! !

!LogConfigurationHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:05'!
at:aConfigurationKey put: aValue
	dict at:aConfigurationKey put:aValue.
	^aValue.! !

!LogConfigurationHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 22:16'!
forClass: aClass
    | rslt | 
	rslt := self at: aClass ifNotConfigured: [
		self loadPragmaConfigurationFrom: aClass ifNotConfiguration:[
			self at: aClass package ifNotConfigured: [
				self at:#default	
			]		
		]
	].
	^rslt.! !

!LogConfigurationHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 22:09'!
initialize 
	super initialize.
	dict := Dictionary new.
	LogConfiguration configuration.
	! !

!LogConfigurationHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 23:33'!
loadPragmaConfigurationFrom: aClass ifNotConfiguration: aBlock
| register  rslt |


" Pragma load configuration rules. "
	register := {
		#logConfiguration -> [  :method :arguments | 
				 (method numArgs = 1) ifTrue:[ 
					aClass perform: (method selector) with:LogConfiguration 
				  ]  ifFalse: [ 
					LogConfiguration for: (aClass perform:method selector) 
				  ] 
		].
		#logConfigurationAs: -> [ :method :arguments |   
				LogConfigurationHolder instance at:(arguments at:1) ifNotConfigured: [self error: 'there is not default configuration!! ' ] 
		]  .
	} asDictionary.

" Pragma load configuration rules apply "	
	register associationsDo: [ :assoc | 
		| array |
		array := Pragma allNamed:assoc key in: aClass class.
		array size > 0 ifTrue:[
			rslt := assoc value value: ((array at:1 )method ) value:((array at:1 )arguments).
			rslt ifNotNil: [
				^rslt.	
			]
		].
	].

	^aBlock value.
	
	! !

Object subclass: #LogEntity
	instanceVariableNames: 'originObject originSelector arguments tag logBlock timestamp pid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe'!

!LogEntity class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 5/31/2012 03:52'!
for:aLog in:aContext with:aTag
	|i|
	i:= self new.
	^i logBlock:aLog ; 
			  originObject: aContext receiver;
			  originSelector: aContext method selector;
			  arguments: aContext arguments;
			  tag: aTag;
			  pid: (Processor activeProcess hash \\ 999999);
			  timestamp: TimeStamp current;
			  yourself.
				! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:56'!
arguments
	^ arguments! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:56'!
arguments: anObject
	arguments := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:05'!
asString 
	^ pid asString, '@', timestamp asString, ' #', originObject class name, '>>', originSelector,'::', logBlock value asString.! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:56'!
logBlock
	^ logBlock! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:56'!
logBlock: anObject
	logBlock := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:27'!
originClass
	^ originObject class.! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
originObject
	^ originObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
originObject: anObject
	originObject := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
originSelector
	^ originSelector! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
originSelector: anObject
	originSelector := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:02'!
pid
	^ pid! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:02'!
pid: anObject
	pid := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
tag
	^ tag! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:57'!
tag: anObject
	tag := anObject! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:02'!
timestamp
	^ timestamp! !

!LogEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:02'!
timestamp: anObject
	timestamp := anObject! !

Object subclass: #LogFileWriter
	instanceVariableNames: 'path stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Writer'!

!LogFileWriter class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 5/31/2012 03:47'!
for: aPath
	| i |
	i := self new.
	^i path: aPath;open;yourself.
	! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:15'!
close
	self stream ifNil: [ ^ self ].
	stream close. 
	stream := nil.! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:20'!
open
	| fileStream |
	self close .
	fileStream := FileStream fileNamed: self path.
	fileStream setToEnd.
	self stream: fileStream.
	! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:14'!
path
	^path.! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:14'!
path: aPath
	path := aPath.! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:16'!
stream
	^ stream! !

!LogFileWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:16'!
stream: aStream
	stream := aStream! !

!LogFileWriter methodsFor: 'write' stamp: 'SantiagoBragagnolo 5/31/2012 02:21'!
write: aString
	self stream nextPutAll: aString.
	self stream nextPut: Character cr.
	self stream lf.
	! !

Object subclass: #LogFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Filter'!

LogFilter subclass: #CategoryLogFilter
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Filter'!

!CategoryLogFilter class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:47'!
for: aCategory
	| i |
	i := self new.
	^i category: aCategory; yourself .! !

!CategoryLogFilter methodsFor: 'filter' stamp: 'SantiagoBragagnolo 5/31/2012 02:02'!
accept: aLogEntity 
	^ aLogEntity tag = self category.! !

!CategoryLogFilter methodsFor: 'filter' stamp: 'SantiagoBragagnolo 5/31/2012 02:02'!
category 
	^category.! !

!CategoryLogFilter methodsFor: 'filter' stamp: 'SantiagoBragagnolo 5/31/2012 02:02'!
category: aCategory 
	category := aCategory.! !

CategoryLogFilter subclass: #LevelLogFilter
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Filter'!

!LevelLogFilter methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:50'!
accept: aLogEntity 
	^( TagLevels at:(aLogEntity tag)) <= (TagLevels at:(self category)).! !

!LogFilter methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 01:58'!
accept: aLogEntity 
	self subclassResponsibility.! !

!LogFilter methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 01:58'!
ifAccept: aLogEntity do: aBlock
	^(self accept: aLogEntity) ifTrue:aBlock.! !

Object subclass: #LogHolder
	instanceVariableNames: 'logs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Holder'!

LogHolder class
	instanceVariableNames: 'instance'!

LogHolder class
	instanceVariableNames: 'instance'!

!LogHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:58'!
instance
	instance ifNil:[
		instance := self basicNew.	
		instance initialize.
	].
	^instance.! !

!LogHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:30'!
new
	self error: 'LogHolder is a singleton!!'.! !

!LogHolder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 03:58'!
reset
	instance := nil.! !

!LogHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 23:05'!
add: aLog
	logs add: aLog.
	(logs size > self limit) ifTrue: [ 
		logs remove: (logs indexOf: logs last)
	].

! !

!LogHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:29'!
collect: aBlock
	^logs collect: aBlock.
	! !

!LogHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:28'!
initialize
	logs := OrderedCollection new.! !

!LogHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 23:04'!
limit 
	^1000.! !

!LogHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:29'!
select: aBlock
	^logs select: aBlock.
	! !

Object subclass: #LogProcessor
	instanceVariableNames: 'filter formatter writer hold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe'!

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:41'!
filter
	^ filter! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:42'!
filter: aFilter
	filter := aFilter! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:41'!
formatter
	^ formatter! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:43'!
formatter: aFormatter
	formatter := aFormatter! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:52'!
hold
	^hold.! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:52'!
hold: aBoolean
	hold := aBoolean.! !

!LogProcessor methodsFor: 'process' stamp: 'SantiagoBragagnolo 5/31/2012 02:53'!
process: aLogEntity
	self filter ifAccept: aLogEntity do: [
		| log |
		log := self formatter format:aLogEntity.
		self writer write: log.
		self hold ifTrue: [ LogHolder instance add: aLogEntity ].
	]
! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:41'!
writer
	^ writer! !

!LogProcessor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 00:43'!
writer: aWritter
	writer := aWritter! !

Object subclass: #LogStdoutWriter
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Writer'!

!LogStdoutWriter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 02:22'!
stream
	^ stream ifNil: [
		(stream := FileStream stdout)
			wantsLineEndConversion: true;
			converter; "Force lazy initialization of converter"
			yourself ]! !

!LogStdoutWriter methodsFor: 'write' stamp: 'SantiagoBragagnolo 5/31/2012 02:22'!
write: aString
	self stream nextPutAll: aString.
	self stream nextPut: Character cr.
	self stream lf.
	! !

Object subclass: #LoggedExampleCustomized
	uses: TLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Examples'!

LoggedExampleCustomized class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!LoggedExampleCustomized class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 6/2/2012 01:04'!
configurationOfLog
	<logConfiguration>
	^ [
	     :builder |
	     builder forClass:LoggedExampleCustomized 
			     useLevel:#warn 
			     showingLogAs: ('%pih | %tstmp | %tag #%class >> %selector [%log]' asPatternFormatter) 
			     into: { Transcript asLogWriter . Transcript asLogWriter } asLogWriter.
	].

! !

!LoggedExampleCustomized methodsFor: 'logging' stamp: 'SantiagoBragagnolo 6/2/2012 01:05'!
example
" self new example. "

" default configuration uses two instances of TranscriptLogWriter in a LogCompositeWriter, so the available log must be repeated. "
	Transcript open.
" default configuration use levels and is setted in warn level. So, you must see just the error log "
	self debug:'something #debug'.
	self info:'something #info'.
	self logError:[ 'something #error' ].
" If you want to change the configuration of your class, your class already have a resetConfiguration :) 'cause of TLogger trait :)  "	
	self class resetConfiguration.
	
	
	
	
	! !

Object subclass: #LoggedExampleDefault
	uses: TLogger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Examples'!

LoggedExampleDefault class
	uses: TLogger classTrait
	instanceVariableNames: ''!

!LoggedExampleDefault methodsFor: 'logging' stamp: 'SantiagoBragagnolo 6/2/2012 01:05'!
example
" self new example. "

" default configuration uses TranscriptLogWriter "
	Transcript open.
" default configuration use levels and is setted in warn level. So, you must see just the error log "
	self debug:'something #debug'.
	self info:'something #info'.
	self logError:[ 'something #error' ].
" If you want to change the configuration of your class, your class already have a resetConfiguration :) 'cause of TLogger trait :)  "	
	self class resetConfiguration.
	
	
	
	
	! !

Object subclass: #MemoryLogWritter
	instanceVariableNames: 'logs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Writer'!

!MemoryLogWritter methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 5/31/2012 22:40'!
initialize 
	logs := OrderedCollection new.! !

!MemoryLogWritter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 22:41'!
logs 
	 ^logs.! !

!MemoryLogWritter methodsFor: 'write' stamp: 'SantiagoBragagnolo 5/31/2012 22:40'!
write: aString
	logs add:aString.! !

Object subclass: #PatternLogFormatter
	instanceVariableNames: 'pattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Formatter'!

!PatternLogFormatter commentStamp: '<historical>' prior: 0!
Format a LogEntity using a pattern string where

%log means log
%class means class
%selector means selector
%arg means arguments array (if any)
%tstmp means timestamp
%pid means process id
%tag means category or level (aka tag)


!

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:35'!
argument
	^'%arg'.! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:34'!
classSymbol
	^'%class'.! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:34'!
log
	^'%log'.! !

!PatternLogFormatter class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 5/31/2012 01:12'!
new 
	self error: 'PatternLogFormatter must be instanciated with with:aStringPattern class message'! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 23:46'!
pih
	^'%pih'.! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:35'!
selector
	^'%selector'.! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:35'!
tag
	^'%tag'.! !

!PatternLogFormatter class methodsFor: 'symbols' stamp: 'SantiagoBragagnolo 5/31/2012 01:35'!
timestamp
	^'%tstmp'.! !

!PatternLogFormatter class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 5/31/2012 03:48'!
with:aStringPattern
	| i |
	i := self basicNew .
	^i pattern:aStringPattern ; yourself.
	! !

!PatternLogFormatter methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 23:47'!
format: aLogEntity
	| result arguments |
	
	result := pattern copyReplaceAll:  PatternLogFormatter pih with: aLogEntity pid asString.
	result := result copyReplaceAll:  PatternLogFormatter log with: aLogEntity logBlock value asString.
	result := result copyReplaceAll:  PatternLogFormatter classSymbol with: aLogEntity originClass name.
	result := result copyReplaceAll:  PatternLogFormatter selector with: aLogEntity originSelector.	
	result := result copyReplaceAll:  PatternLogFormatter timestamp with: aLogEntity timestamp asString.
	result := result copyReplaceAll:  PatternLogFormatter tag with: aLogEntity tag.
	
	arguments := aLogEntity arguments  collect:#asString.
	
	arguments size > 0 ifTrue: [ 
		result := result copyReplaceAll:  PatternLogFormatter argument with: arguments asString.			
	] ifFalse:[
		result := result copyReplaceAll:  PatternLogFormatter argument with: ''.
	].

	^result.! !

!PatternLogFormatter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:12'!
pattern
	^pattern.! !

!PatternLogFormatter methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/31/2012 01:12'!
pattern:  aStringPattern 
	pattern := aStringPattern.! !

Object subclass: #SimpleLogFormatter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Formatter'!

!SimpleLogFormatter methodsFor: 'format' stamp: 'SantiagoBragagnolo 5/31/2012 01:01'!
format: aLogEntity
	^ aLogEntity asString.! !

Object subclass: #TagLevels
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe'!

!TagLevels class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/31/2012 02:09'!
at:aTag
	^{
		#error -> 0 .
		#warn -> 1 .
		#info -> 2 .
		#debug -> 3.
		#transaction -> 4 .
	} asDictionary at: aTag.! !

Object subclass: #TranscriptLogWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PaulLePoulpe-Writer'!

!TranscriptLogWriter methodsFor: 'write' stamp: 'SantiagoBragagnolo 5/31/2012 02:24'!
write: aString
	Transcript show: aString; cr.! !

!ThreadSafeTranscript methodsFor: '*PaulLePoulpe' stamp: 'SantiagoBragagnolo 5/31/2012 03:02'!
asLogWriter 
	^TranscriptLogWriter new.! !
